﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing ;
using System.Windows.Forms;
namespace UserControl
{
    public partial  class TextClass:System.Windows.Forms.TextBox 
    {
        private System.Drawing.Color FBC=Color.Blue,LFBC ;
        private Font FF = TextClass.DefaultFont, LFF;
        private Boolean ID = false;
        public string FarsiDate = "";
        public System.Drawing.Color FocusBackColor
        {
            get
            {
                return FBC;
            }
            set
            {
                FBC = value;
            }
        }
        public Font FocusFont
        {
            get
            {
                return FF ;
            }
            set
            {
                FF  = value;
            }
        }
        public bool IsDate
        {
            get
            {
                return ID;
            }
            set
            {
                ID = value;
                if (ID == true)
                {
                    this.Text = "13__/__/__";
                    this.Multiline = false;
                }
                else
                {
                    this.Text = "";
                }
            }
        }
        protected override void OnEnter(EventArgs e)
        {
            LFBC = this.BackColor;
            LFF = this.Font;
            this.BackColor = this.FocusBackColor;
            this.Font = this.FocusFont;
            base.OnEnter(e);
        }
        protected override void  OnValidated(EventArgs e)
{
 	 this.BackColor = LFBC;
            this.Font  = LFF;
            base.OnValidated(e);
}
        protected override void OnCreateControl()
        {

            base.OnCreateControl();

        }
        protected override void OnKeyPress(KeyPressEventArgs e)
        {
            if (this.Multiline == true && e.KeyChar == '\n') return;
            string ValidChar = "";
            if (IsDate == true)
            {
                if (Convert.ToInt16(e.KeyChar) == 8)
                {
                    if (this.SelectionStart == 5 || this.SelectionStart == 8)
                    {
                        this.SelectionStart--;
                    }
                    else
                    {
                        if (this.SelectionStart > 0)
                        {
                            int l = this.SelectionStart;
                            this.Text = this.Text.Substring(0, this.SelectionStart - 1) + "_" + this.Text.Substring(this.SelectionStart);
                            this.SelectionStart = l - 1;
                        }
                    }
                    e.KeyChar = Convert.ToChar(0);
                    base.OnKeyPress(e);
                    return;
                }
                if (this.SelectionStart < 10)
                {
                    this.SelectionLength = 1;
                }

                if (this.SelectionStart == 0) ValidChar = "12";
                if (this.SelectionStart == 1 || this.SelectionStart == 2 || this.SelectionStart == 3) ValidChar = "0123456789";
                if (this.SelectionStart == 5) ValidChar = "01";
                if (this.SelectionStart == 6)
                {
                    if (this.Text.Substring(5, 1) == "0") ValidChar = "123456789";
                    if (this.Text.Substring(5, 1) == "1") ValidChar = "012";
                }
                if (this.SelectionStart == 4 || this.SelectionStart == 7)
                {
                    ValidChar = "/";
                    this.SelectionStart += 1;
                }
                if (this.SelectionStart == 8) ValidChar = "0123";
                if (this.SelectionStart == 9)
                {
                    if (this.Text.Substring(8, 1) == "1" || this.Text.Substring(8, 1) == "2") ValidChar = "0123456789";
                    if (this.Text.Substring(8, 1) == "0") ValidChar = "123456789";
                    if (this.Text.Substring(8, 1) == "3")
                    {
                        if (this.Text.Substring(5, 2) == "01" ||
                            this.Text.Substring(5, 2) == "02" ||
                            this.Text.Substring(5, 2) == "03" ||
                            this.Text.Substring(5, 2) == "04" ||
                            this.Text.Substring(5, 2) == "05" ||
                            this.Text.Substring(5, 2) == "06")
                            ValidChar = "01";
                        else ValidChar = "0";

                    }
                }
                if (ValidChar.Contains(e.KeyChar) == false) e.KeyChar = Convert.ToChar(0);
                base.OnKeyPress(e);
            }

            base.OnKeyPress(e);
        }
        protected override void OnTextChanged(EventArgs e)
        {
            if (IsDate == true)
            {
                try
                {
                    int m = Convert.ToInt32(this.Text.Substring(5, 2));
                    int d = Convert.ToInt32(this.Text.Substring(8, 2));
                    FarsiDate = ChangeDateToChar(m, d);
                }
                catch { FarsiDate = "فرمت غير قابل قبول"; }
            }
            else FarsiDate = "فيلد تاريخ نيست";
                
            base.OnTextChanged(e);
        }
        private string  ChangeDateToChar(int Mounth,int Day)
        {
            string ret = "";
            ret = NumberToChar(Day) + " " + ChangeMounth  (Mounth);
                return ret;
        }
        private string NumberToChar(int d)
        {
            switch (d)
            {
                case 1: return "يكم";
                case 2: return "دوم";
                case 3: return "سوم";
                case 4: return "چهارم";
                case 5: return "پنجم";
                case 6: return "ششم";
                case 7: return "هفتم";
                case 8: return "هشتم";
                case 9: return "نهم";
                case 10: return "دهم";
                case 11: return "يازدهم";
                case 12: return "دوازدهم";
                case 13: return "سيزدهم";
                case 14: return "چهاردهم";
                case 15: return "پانزدهم";
                case 16: return "شانزدهم";
                case 17: return "هفدهم";
                case 18: return "هجدهم";
                case 19: return "نوزدهم";
                case 20: return "بيستم";
                case 21: return "بيست ويكم";
                case 22: return "بيست و دوم";
                case 23: return "بيست و سوم";
                case 24: return "بيست و چهارم";
                case 25: return "بيست پنجم";
                case 26: return "بيست و ششم";
                case 27: return "بيست و هفتم";
                case 28: return "بيست و هشتم";
                case 29: return "بيست و نهم";
                case 30: return "سي ام";
                case 31: return "سي و يكم";
                default: return "نامشخص";
            }
        }
        private string ChangeMounth(int Mounth)
        {
            switch (Mounth)
            {
                case 1: return "فروردين";
                case 2: return "ارديبهشت";
                case 3: return "خرداد";
                case 4: return "تير";
                case 5: return "مرداد";
                case 6: return "شهريور";
                case 7: return "مهر";
                case 8: return "آبان";
                case 9: return "آذر";
                case 10: return "دي";
                case 11: return "بهمن";
                case 12: return "اسفند";
                default: return "نامشخص";
            }
        }
    }
}
